/*
 * Created on 24.12.2004 by HS
 * 
 */
package de.laliluna.relations;

import java.rmi.RemoteException;
import java.util.Properties;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;



import de.laliluna.relations.many2many.interfaces.TestPupilTeacher;
import de.laliluna.relations.many2many.interfaces.TestPupilTeacherHome;
import de.laliluna.relations.many2manyUni.interfaces.TestIdiotQuestion;
import de.laliluna.relations.many2manyUni.interfaces.TestIdiotQuestionHome;
import de.laliluna.relations.one2many.interfaces.*;
import de.laliluna.relations.one2manyUni1.interfaces.TestBedColour;
import de.laliluna.relations.one2manyUni1.interfaces.TestBedColourHome;
import de.laliluna.relations.one2manyUni2.interfaces.TestTreeLeaf;
import de.laliluna.relations.one2manyUni2.interfaces.TestTreeLeafHome;
import de.laliluna.relations.one2one.interfaces.*;
import de.laliluna.relations.one2oneUni.interfaces.*;

/**
 * @author HS
 *
 * 
 */
public class TestRelations {

  private InitialContext context = null;

  /**
   * init the properties you need for the JNDI lookups
   * @return
   */
  private Properties initProperties(){
    Properties properties = new Properties();
    properties.put("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
    properties.put("java.naming.factory.url.pkgs","org.jboss.naming:org.jnp.interfaces");
    properties.put("java.naming.provider.url","jnp://localhost:1099");
    properties.put("jnp.disableDiscovery","true");
    return properties;
  }
  
  public static void main(String[] args) {
    TestRelations relations = new TestRelations();
    try {
      relations.context = new InitialContext(relations.initProperties());

      /*relations.testOne2OneCat();
      relations.testOne2OneDog();
      relations.testOne2MultiFishFinger();
      relations.testOne2MultiBedColour();*/
      relations.testOne2MultiTreeLeaf();
      relations.testMany2ManyPupilteacher();
      relations.testMany2ManyIdiotQuestion();
    } catch (NamingException e) {
      e.printStackTrace();
    } catch (RemoteException e) {
      e.printStackTrace();
    } catch (CreateException e) {
      e.printStackTrace();
    }
  }

  /**
   * calls the session bean which tests the 1:1 relation
   * @throws NamingException
   * @throws RemoteException
   * @throws CreateException
   */
  private void testOne2OneCat() throws NamingException, RemoteException,
      CreateException {
    Object obj = context.lookup(TestCatHouseHome.JNDI_NAME);
    TestCatHouseHome catHouseHome = (TestCatHouseHome) PortableRemoteObject
        .narrow(obj, TestCatHouseHome.class);
    TestCatHouse catHouse = catHouseHome.create();
    catHouse.createRelation();
  }
  
  /**
   * testing dog and bone
   * @throws NamingException
   * @throws RemoteException
   * @throws CreateException
   */
  private void testOne2OneDog() throws NamingException, RemoteException, CreateException{
    Object object = context.lookup(TestDogBoneHome.JNDI_NAME);
    TestDogBoneHome dogBoneHome = (TestDogBoneHome) PortableRemoteObject.narrow(object, TestDogBoneHome.class);
    TestDogBone testDogBone = dogBoneHome.create();
    testDogBone.createRelation();
    testDogBone.deleteRelation();
  }
  
  /**
   * testing fish and fingers
   * @throws NamingException
   * @throws RemoteException
   * @throws CreateException
   */
  private void testOne2MultiFishFinger() throws NamingException, RemoteException, CreateException{
    Object object = context.lookup(TestFishFingersHome.JNDI_NAME);
    TestFishFingersHome home = (TestFishFingersHome)PortableRemoteObject.narrow(object, TestFishFingersHome.class);
    TestFishFingers testFishFingers = home.create();
    testFishFingers.createRelation1();
    testFishFingers.createRelation2();
    testFishFingers.createRelation3();
  }
  
  /**
   * testing bed and colour
   * @throws EJBException
   * @throws NamingException
   * @throws RemoteException
   * @throws CreateException
   */
  private void testOne2MultiBedColour() throws EJBException, NamingException, RemoteException, CreateException{
    Object object = context.lookup(TestBedColourHome.JNDI_NAME);
    TestBedColourHome home = (TestBedColourHome)PortableRemoteObject.narrow(object, TestBedColourHome.class);
    TestBedColour testBedColour = home.create();
    testBedColour.createRelation();
    
  }  
  
  /**
   * testing tree and leafs
   * @throws EJBException
   * @throws NamingException
   * @throws RemoteException
   * @throws CreateException
   */
  private void testOne2MultiTreeLeaf() throws EJBException, NamingException, RemoteException, CreateException{
    Object object = context.lookup(TestTreeLeafHome.JNDI_NAME);
    TestTreeLeafHome home = (TestTreeLeafHome)PortableRemoteObject.narrow(object, TestTreeLeafHome.class);
    TestTreeLeaf testTreeLeaf = home.create();
    testTreeLeaf.createRelation();
    
  }
  
  /**
   * testing pupils and teachers
   * @throws EJBException
   * @throws NamingException
   * @throws RemoteException
   * @throws CreateException
   */
  private void testMany2ManyPupilteacher() throws EJBException, NamingException, RemoteException, CreateException{
    Object object = context.lookup(TestPupilTeacherHome.JNDI_NAME);
    TestPupilTeacherHome home = (TestPupilTeacherHome)PortableRemoteObject.narrow(object, TestPupilTeacherHome.class);
    TestPupilTeacher testPupilTeacher  = home.create();
    testPupilTeacher.createRelation();
    
  }
  
  /**
   * testing idiots and questions
   * @throws EJBException
   * @throws NamingException
   * @throws RemoteException
   * @throws CreateException
   */
  private void testMany2ManyIdiotQuestion() throws EJBException, NamingException, RemoteException, CreateException{
    Object object = context.lookup(TestIdiotQuestionHome.JNDI_NAME);
    TestIdiotQuestionHome home = (TestIdiotQuestionHome)PortableRemoteObject.narrow(object, TestIdiotQuestionHome.class);
    TestIdiotQuestion testTreeLeaf = home.create();
    testTreeLeaf.createRelation();
    
  }
}