/*
 * Created on 15.02.2005 by HS
 * 
 */
package de.laliluna.relations.many2many.ejb;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.laliluna.relations.many2many.interfaces.PupilLocal;
import de.laliluna.relations.many2many.interfaces.PupilLocalHome;
import de.laliluna.relations.many2many.interfaces.TeacherLocal;
import de.laliluna.relations.many2many.interfaces.TeacherLocalHome;

/**
 * XDoclet-based session bean.  The class must be declared
 * public according to the EJB specification.
 *
 * To generate the EJB related files to this EJB:
 *		- Add Standard EJB module to XDoclet project properties
 *		- Customize XDoclet configuration for your appserver
 *		- Run XDoclet
 *
 * Below are the xdoclet-related tags needed for this EJB.
 * 
 * @ejb.bean name="TestPupilTeacher"
 *           display-name="Name for TestPupilTeacher"
 *           description="Description for TestPupilTeacher"
 *           jndi-name="ejb/TestPupilTeacher"
 *           type="Stateless"
 *           view-type="remote"
 */
public class TestPupilTeacher implements SessionBean
{

  /** The session context */
  private SessionContext context;

  /**
   * 
   */
  public TestPupilTeacher()
  {
    super();
    // :TODO: Auto-generated constructor stub
  }

  /**
   * Set the associated session context. The container calls this method 
   * after the instance creation.
   * 
   * The enterprise bean instance should store the reference to the context 
   * object in an instance variable.
   * 
   * This method is called with no transaction context. 
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void setSessionContext(SessionContext newContext) throws EJBException
  {
    context = newContext;
  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbRemove()
   */
  public void ejbRemove() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbActivate()
   */
  public void ejbActivate() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbPassivate()
   */
  public void ejbPassivate() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }

  /**
   * An example business method
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void createRelation() throws EJBException
  {
    System.out.println("create relation pupil teacher");
    try {
      InitialContext initialContext = new InitialContext();
      PupilLocalHome pupilLocalHome = (PupilLocalHome) initialContext.lookup(PupilLocalHome.JNDI_NAME);
      TeacherLocalHome teacherLocalHome = (TeacherLocalHome) initialContext.lookup(TeacherLocalHome.JNDI_NAME);
      
      System.out.println("create pupil");
      PupilLocal pupilLocal = pupilLocalHome.create();
      System.out.println("create teacher");
      TeacherLocal teacherLocal = teacherLocalHome.create();
      
      teacherLocal.getPupils().add(pupilLocal);
    } catch (NamingException e) {
      e.printStackTrace();
    } catch (CreateException e) {
      e.printStackTrace();
    }  
  }

}