/*
 * Created on 13.02.2005 by HS
 * 
 */
package de.laliluna.relations.one2manyUni1.ejb;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.laliluna.relations.one2manyUni1.interfaces.BedLocal;
import de.laliluna.relations.one2manyUni1.interfaces.BedLocalHome;
import de.laliluna.relations.one2manyUni1.interfaces.ColourLocal;
import de.laliluna.relations.one2manyUni1.interfaces.ColourLocalHome;

/**
 * XDoclet-based session bean.  The class must be declared
 * public according to the EJB specification.
 *
 * To generate the EJB related files to this EJB:
 *		- Add Standard EJB module to XDoclet project properties
 *		- Customize XDoclet configuration for your appserver
 *		- Run XDoclet
 *
 * Below are the xdoclet-related tags needed for this EJB.
 * 
 * @ejb.bean name="TestBedColour"
 *           display-name="Name for TestBedColour"
 *           description="Description for TestBedColour"
 *           jndi-name="ejb/TestBedColour"
 *           type="Stateless"
 *           view-type="remote"
 */
public class TestBedColour implements SessionBean {

  /** The session context */
  private SessionContext context;

  /**
   * 
   */
  public TestBedColour() {
    super();
    // :TODO: Auto-generated constructor stub
  }

  /**
   * An example business method
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void createRelation() throws EJBException {
    System.out.println("creating bed colour relation");
    try {
      InitialContext initialContext = new InitialContext();
      BedLocalHome bedLocalHome = (BedLocalHome) initialContext
          .lookup(BedLocalHome.JNDI_NAME);
      ColourLocalHome colourLocalHome = (ColourLocalHome) initialContext
          .lookup(ColourLocalHome.JNDI_NAME);

      BedLocal bedLocal = bedLocalHome.create();
      bedLocal.setName("my bed");
      ColourLocal colourLocal = colourLocalHome.create();
      colourLocal.setName("blue");

      bedLocal.setColour(colourLocal);

    } catch (NamingException e) {
      e.printStackTrace();
    } catch (CreateException e) {
      e.printStackTrace();
    }

  }

  /**
   * Set the associated session context. The container calls this method 
   * after the instance creation.
   * 
   * The enterprise bean instance should store the reference to the context 
   * object in an instance variable.
   * 
   * This method is called with no transaction context. 
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void setSessionContext(SessionContext newContext) throws EJBException {
    context = newContext;
  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbRemove()
   */
  public void ejbRemove() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbActivate()
   */
  public void ejbActivate() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbPassivate()
   */
  public void ejbPassivate() throws EJBException, RemoteException {
    // :TODO: Auto-generated method stub

  }

}