/*
 * Created on 01.01.2005 by HS
 * 
 */
package de.laliluna.relations.one2oneUni.ejb;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.RemoveException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.laliluna.relations.one2one.interfaces.CatLocal;
import de.laliluna.relations.one2one.interfaces.CatLocalHome;
import de.laliluna.relations.one2one.interfaces.HouseLocal;
import de.laliluna.relations.one2one.interfaces.HouseLocalHome;
import de.laliluna.relations.one2oneUni.interfaces.BoneLocal;
import de.laliluna.relations.one2oneUni.interfaces.BoneLocalHome;
import de.laliluna.relations.one2oneUni.interfaces.DogLocal;
import de.laliluna.relations.one2oneUni.interfaces.DogLocalHome;

/**
 * XDoclet-based session bean.  The class must be declared
 * public according to the EJB specification.
 *
 * To generate the EJB related files to this EJB:
 *		- Add Standard EJB module to XDoclet project properties
 *		- Customize XDoclet configuration for your appserver
 *		- Run XDoclet
 *
 * Below are the xdoclet-related tags needed for this EJB.
 * 
 * @ejb.bean name="TestDogBone"
 *           display-name="Name for TestDogBone"
 *           description="Description for TestDogBone"
 *           jndi-name="ejb/TestDogBone"
 *           type="Stateless"
 *           view-type="remote"
 */
public class TestDogBone implements SessionBean
{

  /** The session context */
  private SessionContext context;

  /**
   * 
   */
  public TestDogBone()
  {
    super();
    // :TODO: Auto-generated constructor stub
  }

  /**
   * An example business method
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void createRelation() throws EJBException {
    // [laliluna] 24.12.2004 we need a context to lookup the localHome Interfaces
    InitialContext initialContext;
    try {
      initialContext = new InitialContext();
      DogLocalHome dogLocalHome;
      BoneLocalHome boneLocalHome;
      /*
       * [laliluna] 
       * we use local interfaces, so there is not need to use
       * PortableRemoteObject.narrow
       */
      dogLocalHome = (DogLocalHome) initialContext.lookup(DogLocalHome.JNDI_NAME);
      boneLocalHome = (BoneLocalHome) initialContext.lookup(BoneLocalHome.JNDI_NAME);
      
      DogLocal dogLocal = dogLocalHome.create();
      dogLocal.setName("Karl");
      BoneLocal boneLocal = boneLocalHome.create();
      boneLocal.setSize("big");
      
      // [laliluna] now set the relation
      dogLocal.setBone(boneLocal);
      
    } catch (NamingException e) {
      throw new EJBException(e);
    } catch (CreateException e) {
      throw new EJBException(e);
    }
  }
  
  /**
   * An example business method
   *
   * @ejb.interface-method view-type = "remote"
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void deleteRelation() throws EJBException {
    // [laliluna] 24.12.2004 we need a context to lookup the localHome Interfaces
    InitialContext initialContext;
    try {
      initialContext = new InitialContext();
      DogLocalHome dogLocalHome;
      BoneLocalHome boneLocalHome;
      /*
       * [laliluna] 
       * we use local interfaces, so there is not need to use
       * PortableRemoteObject.narrow
       */
      dogLocalHome = (DogLocalHome) initialContext.lookup(DogLocalHome.JNDI_NAME);
      boneLocalHome = (BoneLocalHome) initialContext.lookup(BoneLocalHome.JNDI_NAME);
      
      DogLocal dogLocal = dogLocalHome.create();
      dogLocal.setName("Karl");
      BoneLocal boneLocal = boneLocalHome.create();
      boneLocal.setSize("big");
      
      // [laliluna] now set the relation
      dogLocal.setBone(boneLocal);
      
      // [laliluna] delete the bone and see what happen
      boneLocal.remove();
      
    } catch (NamingException e) {
      throw new EJBException(e);
    } catch (CreateException e) {
      throw new EJBException(e);
    } catch (EJBException e) {
     throw new EJBException(e);
    } catch (RemoveException e) {
      // :TODO: Auto-generated catch block
      e.printStackTrace();
    }
  }
  
  
  
  /**
   * Set the associated session context. The container calls this method 
   * after the instance creation.
   * 
   * The enterprise bean instance should store the reference to the context 
   * object in an instance variable.
   * 
   * This method is called with no transaction context. 
   * 
   * @throws EJBException Thrown if method fails due to system-level error.
   */
  public void setSessionContext(SessionContext newContext) throws EJBException
  {
    context = newContext;
  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbRemove()
   */
  public void ejbRemove() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbActivate()
   */
  public void ejbActivate() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }

  /* (non-Javadoc)
   * @see javax.ejb.SessionBean#ejbPassivate()
   */
  public void ejbPassivate() throws EJBException, RemoteException
  {
    // :TODO: Auto-generated method stub

  }


}